<template>
	<xn-form-container
		:title="formData.id ? '编辑租户' : '增加租户'"
		:width="700"
		:visible="visible"
		:destroy-on-close="true"
		@close="onClose"
	>
		<a-form ref="formRef" :model="formData" :rules="formRules" layout="vertical">
			<a-row :gutter="16">
				<a-col :span="12">
					<a-form-item label="名称：" name="name" required>
						<a-input v-model:value="formData.name" placeholder="请输入名称"/>
					</a-form-item>
				</a-col>
				<a-col :span="12">
					<a-form-item label="手机号：" name="phone" required>
						<a-input v-model:value="formData.phone" placeholder="请输入手机号"/>
					</a-form-item>
				</a-col>
				<a-col :span="12" v-if="!formData.id">
					<a-form-item label="用户名：" name="account" required>
						<a-input v-model:value="formData.account" placeholder="请输入用户名"/>
					</a-form-item>
				</a-col>
			</a-row>
		</a-form>
		<template #footer>
			<a-button style="margin-right: 8px" @click="onClose">关闭</a-button>
			<a-button type="primary" @click="onSubmit" :loading="submitLoading">保存</a-button>
		</template>
	</xn-form-container>
</template>

<script setup name="sysTenantForm">

import {cloneDeep} from "lodash-es";
import {required} from "@/utils/formRules";
import sysTenantApi from "@/api/sys/sysTenantApi";
// 抽屉状态
const visible = ref(false);
const emit = defineEmits({successful: null});
const formRef = ref();
// 表单数据
const formData = ref({});
const submitLoading = ref(false);

// 打开抽屉
const onOpen = (record) => {
	visible.value = true;
	if (record) {
		let recordData = cloneDeep(record);
		formData.value = Object.assign({}, recordData);
	}
};
// 关闭抽屉
const onClose = () => {
	formRef.value.resetFields();
	formData.value = {};
	visible.value = false;
};
// 默认要校验的
const formRules = {};
// 验证并提交数据
const onSubmit = () => {
	formRef.value.validate().then(() => {
		submitLoading.value = true;
		const formDataParam = cloneDeep(formData.value);
		sysTenantApi
			.sysTenantSubmitForm(formDataParam, formDataParam.id)
			.then(() => {
				onClose();
				emit("successful");
			})
			.finally(() => {
				submitLoading.value = false;
			});
	});
};
// 抛出函数
defineExpose({
	onOpen
});
</script>
